<?php


namespace app\cxinv\model;


use think\facade\Log;
use think\model\concern\SoftDelete;
class InvoiceOrder extends Base{

    use SoftDelete;
    protected $createTime='createTime';
    protected $updateTime='updateTime';
    protected $autoWriteTimestamp=true;
    protected $deleteTime='delete_time';
    protected $append=["merge_code","short_name","cat_code","cat_name","tax","inv_good_name"];
    public function ItemInfo(){
        return $this->hasOne('InvoiceItem','itemId','id');
    }
    public static function getInvoiceOrderTotalFee($code){
        $banance =  (new InvoiceOrder)->where(['code'=>$code,'status'=>[1,2]])->field('sum(ifnull(total_amount-balance_amount,0)) as total_amount')->find();
        return $banance['total_amount']??"0";
    }

    public function getMergeCodeAttr($value,$data){
        return OrderCategory::where(['code'=>$data['code'],'spuCode'=>$data['spuCode']])->value("merge_code","");
    }
    public function getShortNameAttr($value,$data){
        return OrderCategory::where(['code'=>$data['code'],'spuCode'=>$data['spuCode']])->value("short_name","");
    }
    public function getCatCodeAttr($value,$data){
        return OrderCategory::where(['code'=>$data['code'],'spuCode'=>$data['spuCode']])->value("cat_code","");
    }
    public function getCatNameAttr($value,$data){
        return OrderCategory::where(['code'=>$data['code'],'spuCode'=>$data['spuCode']])->value("cat_name","");
    }

    public function getTaxAttr($value,$data){
        return OrderCategory::where(['code'=>$data['code'],'spuCode'=>$data['spuCode']])->value("tax","");
    }
    public function getInvGoodNameAttr($value,$data){
        return OrderCategory::where(['code'=>$data['code'],'spuCode'=>$data['spuCode']])->value("inv_good_name","");
    }
     public static function getNumAttr($val){
        return  strval(floatval($val));
    }

    public static function setDiffInfoAttr($val){
        return  json_encode($val,JSON_UNESCAPED_UNICODE);
    }
    public static function getDiffInfoAttr($val){
        return  json_decode($val,true);
    }

    public static function getOrderInfo($code,$orderCode,$type){
       if($type==1){
           $info=InvoiceGood::alias('a')
                ->join('qrd_info b','a.orderCode=b.sequenceNo','left')
                ->join('order_category c','b.sequenceNo=c.code and b.goodNo=c.spuCode and  c.order_type=1','left')
                ->where(["invNo"=>$code,"a.orderCode"=>$orderCode])
                ->where([['a.goodNum','>',0],['a.is_del','=',0]])
                ->field('b.sequenceNo,b.goodNo,b.goodName,a.goodNum,a.goodPrice,a.totalPrice,c.merge_code,c.cat_code,c.cat_name,c.short_name,c.tax,c.inv_good_name')
                ->findOrEmpty();
          } else{
           $payNo = PayInvoice::where(['hpNo'=>$code])->value("payNo","");
           $info = PayInfo::alias('a')
                ->join('cgd_info b','a.cgdNo=b.sequenceNo','left')
                ->join('order_category c','b.sequenceNo=c.code and b.goodNo=c.spuCode and c.order_type=2','left')
                ->where([['a.status','=',1],['a.is_del','=',0],['a.payNo',"=",$payNo ],['a.cgdNo',"=",$orderCode]])
                ->field('b.sequenceNo,b.goodNo,b.goodName,(b.goodNum-thNum) as goodNum,b.goodPrice,b.totalPrice,
                c.merge_code,c.cat_code,c.cat_name,c.short_name,c.tax,c.inv_good_name')
                ->findOrEmpty();
        }
       if(!$info->isEmpty())$info['balance_amount']= bcsub($info['totalPrice'],InvoiceOrder::getInvoiceOrderTotalFee($info['sequenceNo']),2);
       return $info;
    }

    //回票流程结束未认证 状态3  退票认证结束 状态4
    public static function onAfterWrite($model){
      $id= $model->id;
      $info = InvoiceOrder::where(['id'=>$id])->findOrEmpty();
      if(!$info->isEmpty())return ;
      if(in_array($info->status,[1,2])){
         $cgdinfo = CgdInfo::where(['sequenceNo'=>$info->code])->findOrEmpty();
         if(!$cgdinfo->isEmpty()){
             $cgdinfo->winv_fee = bcsub($cgdinfo->winv_fee,bcsub($info->total_amount,$info->balance_amount,2),2);
             $cgdinfo->save();
         }
         $payinfo = PayInfo::where(["cgdNo"=>$info->code,"status"=>1,"is_del"=>0])->findOrEmpty();
         if(!$payinfo->isEmpty()){
           $pay= Pay::where(['payNo'=>$payinfo->payNo,"status"=>2])->findOrEmpty();
           if(!$pay->isEmpty()){
               $pay->winv_fee=bcsub($pay->winv_fee,bcsub($info->total_amount,$info->balance_amount,2),2);
               $pay->inv_fee = bcadd($pay->inv_fee,bcsub($info->total_amount,$info->balance_amount,2),2);
               $pay->save();
           }
         }
      }
      if($info->status==3){
          $cgdinfo = CgdInfo::where(['sequenceNo'=>$info->code])->findOrEmpty();
                    if(!$cgdinfo->isEmpty()){
                        $cgdinfo->winv_fee = bcadd($cgdinfo->winv_fee,bcsub($info->total_amount,$info->balance_amount,2),2);
                        $cgdinfo->save();
                    }
                   $payinfo = PayInfo::where(['cgdNo'=>$info->code,'status'=>1,'is_del'=>0])->findOrEmpty();
                   if(!$payinfo->isEmpty()){
                     $pay= Pay::where(['payNo'=>$payinfo->payNo,'status'=>2])->findOrEmpty();
                     if(!$pay->isEmpty()){
                         $pay->winv_fee=bcadd($pay->winv_fee,bcsub($info->total_amount,$info->balance_amount,2),2);
                         $pay->inv_fee = bcsub($pay->inv_fee,bcsub($info->total_amount,$info->balance_amount,2),2);
                         $pay->save();
                     }
                   }
      }
      if($info->status==4){
          $cgdinfo = CgdInfo::where(['sequenceNo'=>$info->code])->findOrEmpty();
          if(!$cgdinfo->isEmpty()){
              $cgdinfo->winv_fee = bcadd($cgdinfo->winv_fee,bcsub($info->total_amount,$info->balance_amount,2),2);
              $cgdinfo->ainv_fee = bcsub($cgdinfo->ainv_fee,bcsub($info->total_amount,$info->balance_amount,2),2);
              $cgdinfo->inv_status = $cgdinfo->ainv_fee==0?1:2;
              $cgdinfo->save();
          }
         $payinfo = PayInfo::where(['cgdNo'=>$info->code,'status'=>1,'is_del'=>0])->findOrEmpty();
         if(!$payinfo->isEmpty()){
           $pay= Pay::where(['payNo'=>$payinfo->payNo,'status'=>2])->findOrEmpty();
           if(!$pay->isEmpty()){
               $pay->winv_fee=bcadd($pay->winv_fee,bcsub($info->total_amount,$info->balance_amount,2),2);
               $pay->ainv_fee = bcsub($pay->ainv_fee,bcsub($info->total_amount,$info->balance_amount,2),2);
               $pay->inv_status = $pay->ainv_fee==0?1:2;
               $pay->save();
           }
         }
      }
    }
}